#include "aaudio.h"
#include "afile.h"

#include <windows.h>
#include <Mmsystem.h>

//Define this to use mciSendString API instead of mciSendCommand API
//#define _A_MCISENDSTRING_

bool ASoundFile::open()
{
    if (m_bWave)
    {
        return true;
    }

    // Open command
#ifdef _A_MCISENDSTRING_
    //http://www.apitalk.com/windows-Programming/Play-Mp3,-Wav,-Wmv,-Mpg,-Avi-Etc-Files-In-Win32-Api-Program.html
    wstring str(L"open " + m_sPlayFilePath + L" type mpegvideo alias " + m_sNameAlias);
    MCIERROR e = mciSendString(str.c_str(), NULL, 0, 0);
#else
    //http://cboard.cprogramming.com/windows-programming/17760-how-do-i-play-mp3.html    
    //http://flylib.com/books/en/4.43.1.135/1/
    MCI_OPEN_PARMS op;
    op.lpstrDeviceType = L"mpegvideo";//(wchar_t*)MCI_DEVTYPE_WAVEFORM_AUDIO;//MCI_ALL_DEVICE_ID;
    op.lpstrElementName = m_sPlayFilePath.c_str();
    MCIERROR e = mciSendCommand( NULL, MCI_OPEN, MCI_OPEN_TYPE | MCI_OPEN_ELEMENT, (DWORD)&op);
    m_data = op.wDeviceID;
#endif
    if (e)
    {
        //TODO:
        return false;
    }
    return true;
}

bool ASoundFile::play()
{
    if (m_bWave)
    {
        // http://forum.sources.ru/index.php?showtopic=39948
        // by some reason, wav=waveaudio is missed in C:\WINDOWS\win.ini
        PlaySound(m_sPlayFilePath.c_str(), GetModuleHandle(NULL), 
            SND_FILENAME | (m_bSync ? SND_SYNC : SND_ASYNC) | SND_NODEFAULT); 
        return true;
    }

    // Play command
#ifdef _A_MCISENDSTRING_
    wstring str = L"play " + m_sNameAlias;
    if (m_bSync)
        str += L" wait";
    MCIERROR e = mciSendString(str.c_str(), NULL, 0, 0);
#else
    MCI_PLAY_PARMS pp;
    MCIERROR e = mciSendCommand(m_data, MCI_PLAY, m_bSync ? MCI_WAIT : 0, (DWORD)&pp);
#endif
    if (e)
    {
        //TODO:
        //wchar_t b[256];
        //mciGetErrorString(e, b, sizeof b);
        return false;
    }
    return true;
}

bool ASoundFile::close()
{
    if (m_bWave)
    {
        return true;
    }
#ifdef _A_MCISENDSTRING_
    MCIERROR e = mciSendString((L"close " + m_sNameAlias).c_str(), NULL, 0, 0);
#else    
    MCI_GENERIC_PARMS cp;
    MCIERROR e = mciSendCommand(m_data, MCI_CLOSE, 0, (DWORD)&cp);    
#endif    
    if (e)
    {
        //TODO:
        return false;
    }
    return true;
}

bool APlayList::addSync(const wstring & sound)
{
    wstring localPath = m_cachedPath + sound + L"." + m_type;
    long long length = flength(localPath);

    //TODO: fix hack!
    /*if (length == 0)
    {
        localPath = m_cachedPath + sound + L"." + L"wav";
        length = flength(localPath);
    }*/

    if (length == 0)
    {
        //TODO:see if blocked while downloading and then wait?
        return false;//just marked as not present?
    }
    if (length == -1)//not cached yet
    {
        AStdioFile localFile;
        localFile.open(localPath,L"wb");
        wstring sourcePath = m_sourcePath + sound + L"." + m_type;
        AHttpFile sourceFile;
        if (!sourceFile.open(sourcePath,L"") || sourceFile.read(&localFile) <= 0)
        {
            return false;//local File remains with zero length
        }
    }
    ASoundFile a(localPath);
    a.play();
    return true;
}
