#ifndef _AAUDIO_H_
#define _AAUDIO_H_

#include "autil.h"
#include "aport.h"

#include <queue>

class ASoundFile
{
private:
	ASoundFile(const ASoundFile & other) {} //disable copy for the time being
protected:	
    //parent set//TODO: if needed to notify asynchronously
	wstring m_sNameAlias;//alias/id
	wstring m_sPlayFilePath;//diskfile to play from
	//bool bOpened;
	bool m_bSync;//true = sync, false = async
    bool m_bWave;//if wave file
    unsigned long m_data;//MCI_OPEN_PARMS.wDeviceID
public:	
	virtual bool open();
	virtual bool play();
	virtual bool close();
	ASoundFile(const wstring & sPlayFilePath, bool bSync = true, const wstring & sNameAlias = L"") 
	    : m_sNameAlias(sNameAlias), m_bSync(bSync), m_sPlayFilePath(sPlayFilePath)
	{
        wstring x = sPlayFilePath.substr(sPlayFilePath.length()-4);
        m_bWave = awcsicmp(sPlayFilePath.substr(sPlayFilePath.length()-4).c_str(), L".wav") == 0;
	    open();
	}
	virtual ~ASoundFile()
	{
	    close();
	}
};

class ACachedSound : public ASoundFile
{
    //parent set//TODO: if needed to notify asynchronously
    wstring sOriginFilePath;//diskfile/httpfile to load from
    bool bCached;//if cache found, mark as ready, otherwise check if present and if so start downloadeing otherwise mark to skip
    //thread downloader - download, mark as ready, and notify set
};

class APlayList
{
protected:
    wstring m_sourcePath;//path of original sound store
    wstring m_cachedPath;//path of local sound cache
    wstring m_type;
    queue<ACachedSound> m_sounds;//
    //Lock
    //start - call checker for all sounds in the set
    //iterator - keep last played sound
    //thread wait for iterator-pointed sound to get notified and then either play or skip and then and continue 
public:    
    APlayList()
    {
    }
    void setup(const wstring & sourcePath, const wstring & cachedPath, const wstring & type)
    {
        m_sourcePath = sourcePath;
        m_cachedPath = cachedPath;
        m_type = type;
    }
    bool addSync(const wstring & sound);
};

#endif //_AAUDIO_H_
