/*
 * Copyright 1997-1999 by Anton Kolonin,
 * All rights reserved.
 *
 * This software is the proprietary information of Anton Kolonin. 
 * You shall not disclose this and shall not use it in any way 
 * without of written permission of Anton Kolonin.
 */
package com.vm.visual;

import java.net.*;
import java.awt.*;
import java.applet.Applet;
import com.vm.mind.*;
import com.vm.app.VMResource;
import com.vm.net.MITransporter;

public class VMSpace
{
    protected VMSpace      space;
    public VMPanel         panel;
    public VMControl       control=null;
    public Container       gui_container;
    public VMToolbar       cpanel;
    public VMBorder        center;
    public VMConsole       console;
    public VMChild        dialog;
    //public VMDialog        dialog;
    protected TextField       text;
    protected Button          post;
    protected Button          enter;
    protected Button          delete=null;//20061029
    protected Choice          click;
    protected Choice          drag;
    protected Choice          link;
    protected Choice          worlds;
    protected TextField       world_url=null;//20061028
    protected Choice          views;
    protected Choice          projector;
    protected Checkbox        spread;
    protected Checkbox        draft=null;//20061111
    protected Checkbox        aim=null;//20061111
    protected Checkbox        animate=null;//20061111

    public    MITransporter     m_transporter;
    public    MIWorld           m_world;        // 1:1 Current world
    public VMView               m_viewpoint;
    public String               m_imagebase;

    public VMContainer     vmw_container;
    
	protected MIList     	  m_worlds;       // 1:M Visited worlds


    protected Toolkit     	  m_toolkit;

    protected                 MIStream    st=null;
    
    private boolean           has_GUI=false;
    //private boolean           is_in_applet=false;//20060512


    public VMSpace(VMContainer i_applet,VMContainer i_frame)
    {
        space=this;         // fix!

        if (i_frame!=null) {
            vmw_container = i_frame;
        }
        if (i_applet!=null) {
            vmw_container = i_applet;
        }
        if (vmw_container.isGUI()) {
            gui_container=vmw_container.getContainer();
        }
            
        if (i_applet==null)    
            VMToolkit.setIsInApplication(true);
            
		panel=null;
		cpanel=null;
		console=null;
		dialog=null;

        m_world=new MIWorld(space);
        m_worlds=new MIList();
		m_viewpoint=null;

        if (vmw_container.isGUI())
            m_toolkit = Toolkit.getDefaultToolkit();
	}
    
    public void message(String msg)
    {
        if (space.console!=null)
        {
            space.console.m_textarea.appendText(msg+"\n");
        }
        else
            vmw_container.showStatus(msg);
    }
    
    
    boolean switchToWorld(String worldname) 
    {
            String viewname;
            MIWorld w;
            for (int i=m_worlds.getMin();i<=m_worlds.getMax();i=m_worlds.getNext(i))
            {
                w=(MIWorld)m_worlds.get(i);
                if ( w.m_name.equals(worldname) )
                {
                    m_world=w;
                    if (m_world.m_viewpoints.getCount()>0)
                    {
                        viewname=((VMView)m_world.m_viewpoints.get(0)).m_name;
                        views.select( viewname );
                    }
                    //setViewPoints();
                    selectviewpoint();
                    panel.repaint();
                    setLinks();
                    setPostStatus();
                    return true;
                }
            }
            return false;
    }


    public boolean action(Event evt, Object arg)
    {
        boolean result=false;
        if (evt.id==Event.KEY_ACTION && panel.projector.action(evt,arg))
        {
            panel.repaint();
            result=true;
        }
        else
        if (arg instanceof float[] && panel.projector.action(evt,arg))//20061121
        {
        	//message from wanderer
            panel.repaint();
            result=true;
        }
        else
    	if (evt.target==worlds)
    	{
            result=switchToWorld(worlds.getSelectedItem());
    	}
    	else
    	if (evt.target==link)
    	{
            m_viewpoint.m_link=link.getSelectedItem();
            panel.repaint();
	        result=true;
    	}
    	else
		if (evt.target==spread)
        {
            panel.projector.spreader.toggle(spread.getState());
            result=true;
        }
        else
     	if (evt.target==draft)//20061111
       	{
        	panel.projector.reflectChange();
			panel.repaint();
        	result=true;
       	}
        else
   		if (evt.target==aim)//20061111
   		{
   			if (!aim.getState())//20061202
   				animate.setState(false);
   			else // if (aim.getState())
   			{
   				space.panel.projector.init();
				panel.repaint();
   			}
            result=true;
   		}
        else
      	if (evt.target==animate)//20061111
       	{
   			if (animate.getState())//20061202
   				aim.setState(true);
   			
   			//init the projector anyway so it can toggle the wanderer on/off 
   			//space.panel.projector.init();//20061202
   			
   			//need to enable
   			if (space.panel.projector instanceof VMCameraProjector)
   			{	
   				VMCameraProjector pro = (VMCameraProjector)space.panel.projector; 
   				pro.m_wan.toggle(space.getAnimateMode());//20061202
   			}
   			
            result=true;
       	}
        else
        if (evt.target==projector)
        {
            m_viewpoint.m_projector=projector.getSelectedItem();
            setProjector();
            space.panel.resetSize(); // to fix scrollbars
            panel.repaint();
            result=true;
        }
        else
    	if (evt.target==views)
    	{
            setViewPoints();
            selectviewpoint();
            setLinks();
            panel.repaint();
	        result=true;
    	}
    	else
    	if (evt.target==worlds)
    	{
	        result=true;
    	}
    	else
    	if (arg!=null && arg.equals(VMResource.getString("Console")))
    	{
            runConsole(true);
            // return now, do not pass focus to the Panel
            return true;
    	}
        else
	    if (arg!=null && arg.equals(VMResource.getString("Open")))
        {
	        if (gui_container instanceof Frame)
	        {
	            java.awt.FileDialog fd = new java.awt.FileDialog(
	    			(Frame)gui_container, VMResource.getString("Open"), java.awt.FileDialog.LOAD);
	            fd.show();
	            fd.toFront();
	            String dir = fd.getDirectory(); 
	    		String file = fd.getFile();
	    		if (dir!=null && file!=null)
	    		{
	    			file = dir+file;
	    			jump(file,null,false);
	    		}
	        }
	        else
	        	message("Can not display open file dialog");
        }
    	else
        if (arg!=null && arg.equals(VMResource.getString("Save As")))
        {
    	    if (gui_container instanceof Frame)
    	    {
    	    	java.awt.FileDialog fd = new java.awt.FileDialog(
    	    		(Frame)gui_container, VMResource.getString("Save As"), java.awt.FileDialog.SAVE);
    	        fd.show();
    	        fd.toFront();
    	        String dir = fd.getDirectory(); 
    	    	String file = fd.getFile();
    	    	if (dir!=null && file!=null)
    	    	{
    	    	    file = dir+file;
    	    	    if (getAccessType(file).equals("FILE"))
    	    	    {
    	    	    	m_world.m_name = file;
    	    	    	if (world_url!=null)
    	    	    		world_url.setText(m_world.m_name);
    	    	    	save();
    	    	    }
    	    	}
    	    }
    	    else
    	    	message("Can not display save file dialog");
        }
        else
    	if (arg!=null && (arg.equals(VMResource.getString("Post"))||arg.equals(VMResource.getString("Save"))))
    	{
            save();

            if (m_transporter!=null)
                m_transporter.notifyPlaces();

            result=true;    
    	}
    	else
        if (arg!=null && arg.equals(VMResource.getString("Print")))
        {
        	try {
        		new VMPrinter(panel).print();
        	} catch (Exception e) { 
                message("Print is not allowed in the demo version.");                
            }
        }
	    else
        if (arg!=null && arg.equals(VMResource.getString("Export")))//20070407
        {
        	try {
        		VMExportImageDialog d = new VMExportImageDialog((Frame)gui_container,panel); 
    	        d.show();
    	        d.toFront();
    	        d.export();
        	} catch (Exception e) { 
                message("Image export is not allowed in the demo version.");                
            }
        }
    	if (arg!=null && (arg.equals(VMResource.getString("Reget"))||arg.equals(VMResource.getString("Reload"))))
    	{
            try {
            	if (world_url!=null && !m_world.m_name.equals(world_url.getText()))
            	{
                    jump(world_url.getText(),null,false);
            	}
            	else
            	{
                    String wname=m_world.m_name;
                    String atype=m_world.m_accesstype;
                    m_worlds.del(m_world);
                    m_world=null;
                    System.gc();
                    m_world=new MIWorld(this);
                    m_world.m_name=wname;
                    m_world.m_accesstype=atype;
                    m_worlds.add(m_world);
                    load();
                    setViewPoints();
                    selectviewpoint();
                    setLinks();
                    panel.repaint();
                    result=true;
                }
            } 
            catch (Exception e) 
            { 
                message("VMSpace reget error: "+e);                
            }
    	}
        else
        if (arg!=null && arg.equals(VMResource.getString("Edit"))
        		&& !(evt.target instanceof Choice))
        {
            dialog=vmw_container.createDialog(m_world,this,VMResource.getString("Edit"),0,0,m_viewpoint);
            if (space.dialog==null)
                message("Can not create dialog for view");
            else
            {
                dialog.display();
                return true; // immediately, leave focus at dialog
            }
        }
        else
		if (arg!=null && arg.equals(VMResource.getString("New")))//new view
		{
			VMView new_view = vmw_container.createDefaultView(m_world);
			new_view.setString("NAME",m_viewpoint.m_name + "\'"); 
		    dialog=vmw_container.createDialog(m_world,this,VMResource.getString("New"),0,0,new_view);
		    if (space.dialog==null)
		        message("Can not create dialog for view");
		    else
		    {
		        dialog.display();
		        return true; // immediately, leave focus at dialog
		    }
		}
		else
	    if (arg!=null && arg.equals(VMResource.getString("Delete")) && !(evt.target instanceof Choice))//20061121
		{
	    	//delete view
	    	if (space.views.countItems()>1)
	    	{
		    	if (space.vmw_container instanceof com.vm.app.SWWindow)//20061019
		    	{
		    	    if (space.dialog==null)
		    	    {
		    	    	space.dialog=space.vmw_container.createDialog(space.m_world,space,VMResource.getString("Delete"),0,0,m_viewpoint);//20061019
		    	    	space.dialog.display();
		    	    }
		    	}
		    	else
		    	{
		    		// TBD delete unconditionally 
		    	}
	    	}
		}
	    else
        if (arg!=null && arg.equals(VMResource.getString("Create")))
        {
    	    if (gui_container instanceof Frame)
    	    {
    	    	java.awt.FileDialog fd = new java.awt.FileDialog(
    	    		(Frame)gui_container, VMResource.getString("Create"), java.awt.FileDialog.SAVE);
    	        fd.show();
    	        fd.toFront();
    	        String dir = fd.getDirectory(); 
    	    	String file = fd.getFile();
    	    	if (dir!=null && file!=null)
    	    	{
    	    	    file = dir+file;
    	    	    if (getAccessType(file).equals("FILE"))
    	    	    {
    	    			jump(file,null,true);
    	    	    }
    	    	}
    	    }
    	    else
    	    	message("Can not display save file dialog");
        }
        if (evt.target!=world_url)
        	panel.requestFocus();
    	return result;
    }
    
    
    /* should be altogether with world.changeable() */
    public static String getAccessType(String i_name)
    {
        String upper_name = i_name.toUpperCase();
        boolean isORLFile = upper_name.endsWith(".TXT")||upper_name.endsWith(".ORL");
        boolean isLISPFile = upper_name.endsWith(".LISP")||upper_name.endsWith(".L");

        // imlicit URL to ORL file on web server or servlet
        if ((upper_name.startsWith("HTTP:")&&isORLFile)||
            upper_name.indexOf("/W?")!=-1||
            upper_name.indexOf("/ORL?")!=-1)
            return "HTTP";

        // imlicit ORL text file
        if (isORLFile || isLISPFile)
            return "FILE";
            
/* 
old crap?
        // explicitly specified ORL text protocol?
        if (upper_name.startsWith("TXT:"))
            return "TXT";

        // imlicit ORL text file or servlet
        if (upper_name.endsWith(".TXT")||
            upper_name.endsWith(".ORL")||
            upper_name.indexOf("/W?")!=-1||
            upper_name.indexOf("/ORL?")!=-1)
            return "TXT";
*/            
        
        // text string OR just html page - by default    !!!
        return "";
    }
    

    public static String getAccessName(String i_name)
    {
        if (i_name.toUpperCase().startsWith("TXT:"))
            /*i_name.toUpperCase().startsWith("CGI:"))*/
            return i_name.substring(4);
        return i_name;
    }
    

    /**
        @author Anton Kolonin
        @since 19991029
        */
    /* 20061019 moved to VMContainer
    protected VMToolbar createToolbar()
    {
        return new VMToolbar(this);
    }*/

    /**
        @author Anton Kolonin
        @since 19991029
        */
    protected VMPanel createPanel()
    {
//        return new VM3DCameraPanel(this);
//        return new VM3DPanel(this);
        return new VMPanel(this);
    }

    /**
        @author Anton Kolonin
        @since 19991011
        */
    public void init()
    {
        cpanel = this.vmw_container.createToolbar(this);
        center = new VMBorder();
        {
            center.setLayout(new BorderLayout());
            panel = createPanel();
            center.add("Center", panel);
        }
    }

    /**
        Initializes everything w/o GUI 
        @author Anton Kolonin
        @since 19991027
        */
    public void initSpace(VMContainer container,String message) {
        m_world.m_accesstype=VMSpace.getAccessType(((VMContainer)container).getParameter("world"));//20060512
        m_world.m_name=VMSpace.getAccessName(((VMContainer)container).getParameter("world"));//20060512
        load();             // load data
        setTransporter();
        message(message+" initialized");
    }
        
    /**
        Initializes everything with GUI 
        @author Anton Kolonin
        @since 19991027
        */
    public void init(Container container,String message)
    {
        m_world.m_accesstype=VMSpace.getAccessType(((VMContainer)container).getParameter("world"));//20060512
        m_world.m_name=VMSpace.getAccessName(((VMContainer)container).getParameter("world"));//20060512
        
//System.out.println("param="+((VMContainer)container).getParameter("world")+" == name="+m_world.m_name);        
        
        container.setLayout(new BorderLayout());
        init();

        container.add("East",     space.panel.vert);
        container.add("South",    space.panel.horz);
        container.add("North",    space.cpanel);
        container.add("Center",   space.center);

        container.validate();

        runConsole(false);  // start console
        message("Initializing "+message);

//System.out.println("SIZE 1: "+giu_container.size().width+" "+giu_container.size().height);
        
        setDraftMode(((VMContainer)container).getParameter("draft").equalsIgnoreCase("true"));//20061111
        setAimMode(((VMContainer)container).getParameter("aim").equalsIgnoreCase("true"));//20061111
        setAnimateMode(((VMContainer)container).getParameter("animate").equalsIgnoreCase("true"));//20061111

        load();             // load data
        setWorld();
        setTransporter();
        setViewPoints();
        selectviewpoint();
        
        setClickMode(((VMContainer)container).getParameter("click"));

        setLinks();
        container.layout();
        cpanel.layout();
        center.layout();
        panel.layout();

//System.out.println("SIZE 2: "+giu_container.size().width+" "+giu_container.size().height);            
//        resize(preferredSize()); doesn't work

        message(message+" initialized");
        /*
        space.panel.requestFocus();//20061029
        if (world_url!=null)//20061029
        {
			world_url.transferFocus();//20061029
			cpanel.transferFocus();//20061029
        }
        space.click.requestFocus();//20061029
        */
    }

    
    public void load()
    {
        boolean loaded=false;
        if (m_world.m_name==null)
            return;

        String filename=m_world.m_name;

        /*15.04.99*/
        //hack
        //
        if (vmw_container.isApplet())
        {
            try
            {
              if (!m_world.m_name.toLowerCase().startsWith("http://")) {
                URL documentBase = ((Applet)vmw_container).getDocumentBase();

                String documentname=documentBase.getFile();
                int lastSlash=documentname.lastIndexOf("/");
                // or something like this .......
                if (lastSlash!=-1)
                    filename=documentname.substring(0,lastSlash+1)+m_world.m_name;
                else
                    filename=m_world.m_name;

                message("Protocol: \""+documentBase.getProtocol()+"\"");
                message("Host: \""+documentBase.getHost()+"\"");
                message("Port: \""+documentBase.getPort()+"\""); //?
                message("Base: \""+documentBase.getFile()+"\"");
                message("File: \""+filename+"\"");

                URL targetURL = new URL(documentBase.getProtocol(),documentBase.getHost(),documentBase.getPort(),filename);
                //URL targetURL = new URL(documentBase.getProtocol(),documentBase.getHost(),filename);

                filename=targetURL.toString();
              }
            }catch(Exception e)
            {
                message("Bad URL: "+m_world.m_name+", "+e);
            }
        }
        //hack
        /*15.04.99*/


//System.out.println("file loaded??????");            

        message("Loading "+m_world.m_accesstype+" data: \""+filename+"\"");
        
        st=(filename.toUpperCase().endsWith("LISP"))
            ?new MILispStream(m_world)
            :new MIStream(m_world);
        
        if (st.init(filename,m_world.m_accesstype, "r"))
        {
            m_imagebase=st.getBase();   // default imagebase
//System.out.println("Loading "+m_world.m_name+" as "+m_world.m_accesstype+":"+filename+" from "+m_imagebase);        

            panel.setCursor(Frame.WAIT_CURSOR);

            loaded=st.run(m_world);            // imagebase might be overrided

            panel.setCursor(Frame.DEFAULT_CURSOR);

            st.stop();
        }
        
        if (loaded)
        {
            message("Data loaded");
        }
        else
        {
            message("Not loaded completely");
        }
        //anyway, create default view
		if (m_world.m_viewpoints.getCount()==0)//20061028
        {
			vmw_container.createDefaultView(m_world);//20061028
        }
    }
    
    

    /**
        Checks if all supercategories are system
        @since 19991228
    boolean isNotPurelySystem(MIThing i_thing)
    {
                MIList l=i_thing.getList("IS");
                for ( int i=l.getMin();
                      i<=l.getMax();
                      i=l.getNext(i))
                {
                    if ((((MIThing)l.get(i)).getType()&MIThing.IS_SYSTEM)==0)
                        return false;
                }
                return true;
    }
        */

    public void save()
    {
        message("Saving data to "+m_world.m_name);
//        st=new MIStream(m_world);
        if (st.init(m_world.m_name,m_world.m_accesstype,"w"))
        {
            panel.setCursor(Frame.WAIT_CURSOR);
            if (m_world.save(st))
            {
                message("Data saved");
            }
            panel.setCursor(Frame.DEFAULT_CURSOR);
            st.stop();
////////// hack - otherwise, post doesn't get recognized by servlet
                
////////// hack - otherwise, post doesn't get recognized by servlet
        }
        return;
    }
    

    protected int findChoice(Choice i_choice, String i_string)
    {
        int j;
        for (j=0;j<i_choice.countItems();j++)
        {
            if (i_string.equals(i_choice.getItem(j)))
            {
                return j;
            }
        }
        return -1;
    }

    //20060512    
    /*    
    private void setLinks(MIList signs)
    {
        //String name;//20060512
        MIThing thing;
        for ( int   i=signs.getMin();
                    i<=signs.getMax();
                    i=signs.getNext(i))
        {
            thing=(MIThing)signs.get(i);
            if (thing.m_idea!=null && findChoice(space.link,thing.m_idea.m_name)==-1)
            {
                space.link.addItem(thing.m_idea.m_name);
            }
            setLinks(thing.m_things);
        }
    }
    */
        
    public void setLinks()
    {
        if (m_viewpoint==null)
            return;
        MIList signs=m_world.thing("PROPERTY").m_things;
		/*doesn't work!!!???*
		setLinks(signs);
        doesn't work!!!???**/
		//String name;//20060512
        MIThing thing;
        for ( int   i=signs.getMin();
                    i<=signs.getMax();
                    i=signs.getNext(i))
        {
            thing=(MIThing)signs.get(i);
            if (thing.m_idea!=null && findChoice(space.link,thing.m_idea.m_name)==-1)
            {
                space.link.addItem(thing.m_idea.m_name);
            }
        }
		/**/
        if (m_viewpoint.m_link==null)
            m_viewpoint.m_link=space.link.getSelectedItem();
        else
            space.link.select(m_viewpoint.m_link);
    }

    public void setViewPoints()
    {
        //String selected = space.views.getSelectedItem();//20060512
        String name;
        for ( int   i=m_world.m_viewpoints.getMin();
                    i<=m_world.m_viewpoints.getMax();
                    i=m_world.m_viewpoints.getNext(i))
        {
            name=((VMView)m_world.m_viewpoints.get(i)).m_name;
            if (findChoice(space.views,name)==-1)
            {
                space.views.addItem(name);
                if (i==m_world.m_viewpoints.getMin())
                {
                    space.views.select(name);
                }
            }
        }
        
        if (space.views.countItems()>1)
        {
            space.views.enable();
            if (space.delete!=null) space.delete.enable();
        }
        else
        {
            space.views.disable();
            if (space.delete!=null) space.delete.disable();
        }
    }

    public void selectviewpoint()
    {
        MIWorld c_world;
        for ( int  w=m_worlds.getMin();
                   w<=m_worlds.getMax();
                   w=m_worlds.getNext(w))
        {
            c_world=(MIWorld)m_worlds.get(w);
            if (c_world==null)
                continue;
            for ( int  i=c_world.m_viewpoints.getMin();
                    i<=c_world.m_viewpoints.getMax();
                    i=c_world.m_viewpoints.getNext(i))
            {
                if (((VMView)c_world.m_viewpoints.get(i)).m_name.equalsIgnoreCase(space.views.getSelectedItem()) )
                {
                    m_viewpoint=((VMView)c_world.m_viewpoints.get(i));
                    m_world=m_viewpoint.m_world;
                    if (worlds!=null)
                    	worlds.select(m_world.m_name);
                    setProjector();
                    space.panel.resetSize();
                    space.panel.resetColors();
                    /*
                    space.panel.requestFocus();//20061029
                    if (world_url!=null)//20061029
                    {
						world_url.transferFocus();//20061029
						cpanel.transferFocus();//20061029
                    }
                    space.click.requestFocus();//20061029
                    */
                    return;
                }
            }
        }
    }
    

    void setProjector()
    {
//20010603
//20010902
        //VMProjector p = (m_viewpoint.m_projector.equals("Camera"))?new VMCameraProjector(this,panel):new VMProjector(this,panel);
        VMProjector p = 
            (m_viewpoint.m_projector.equals("Camera"))
                ?new VMCameraProjector(this,panel)
                :new VMProjector(this,panel);
//20010902
//20010603
        resetToolbar(p);
        projector.select(m_viewpoint.m_projector);
//System.out.println("selected:"+m_viewpoint.m_projector);        
        p.init();
        space.panel.projector = p;
    }

    
    protected boolean jump(String i_string,String i_title,boolean create)
    {
        String c_name=getAccessName(i_string);
        String c_type=getAccessType(i_string);

        // http jump by URL link
        if (c_type.equals("") && (i_string.toUpperCase().startsWith("HTTP") || i_string.toUpperCase().startsWith("MAILTO:"))) 
        {
            if (!vmw_container.isApplet())
            {
                message("No browser to load HTML resource");
            }
            else
            {
    	        try
    	        {
                    // the probblem here is that titles like "a@b" or "x.y"
                    // doesn't work properly :-(
                    //
                    //m_world.message("going to "+i_title+" as "+i_string);
    	            /*
                    if (i_title!=null)
                    {
                        ((Applet)vmw_container).getAppletContext().showDocument(new URL(i_string),i_title);
                    }
                    else
                    */
                    {
                        ((Applet)vmw_container).getAppletContext().showDocument(new URL(i_string),"_blank");
//                        ((Applet)vmw_container).getAppletContext().showDocument(new URL(i_string),"_top");
                    }
                    //m_world.message("Ok!");
                    return true;
                }
                catch (MalformedURLException e)
                {
                    m_world.message("VMSpace.jump("+i_string+") : "+e.toString());
                }
            }
        }
        else
        if (c_type.equals("FILE") || c_type.equals("HTTP"))
        {
            try
            {
                views.removeAll();//20060923 make sure old world disappears after reloading!!!
                if (switchToWorld(c_name)==true)
                    return true;

                m_world=new MIWorld(this);
                m_world.m_name=c_name;
                if (world_url!=null)
                	world_url.setText(m_world.m_name);
                m_world.m_accesstype=c_type;
                if (create)//20061028
                	save();
               	load();
                setWorld();
                setTransporter();
                setViewPoints();
                selectviewpoint();
                setLinks();
                cpanel.layout();
                panel.repaint();
                return true;
            }
            catch (Exception e)
            {
                m_world.message("VMSpace.jump("+i_string+") : "+e.toString());
            }
        }
        else
        {
            space.views.select(i_string);
            selectviewpoint();
            setLinks();
    	    panel.repaint();
            return true;
        }
        return false;
    }


    public void setWorld()
    {
    	if (world_url!=null)
    	{
            world_url.setText(m_world.m_name);
            m_worlds.del();//check if this will still enable distributed processing !!! 
    	}
        m_worlds.add(m_world);
        if (worlds!=null)
        {
            worlds.addItem(m_world.m_name);
            worlds.select(m_world.m_name);
            if (worlds.countItems()>1)
            	worlds.enable();
            else
            	worlds.disable();
        }
        setPostStatus();                
    }


    /**
    @since 20010624
    */
    void setPostStatus()
    {
            if (
                 // applet with no servlet
                 (
                     space.vmw_container.isApplet()
                     &&
                     !(m_world.m_name.toUpperCase().indexOf("/W?")!=-1||m_world.m_name.toUpperCase().indexOf("/ORL?")!=-1)
                 )
                 ||  
                 // application with http access with no servlet
                 (      
                     !space.vmw_container.isApplet()
                     &&
                     m_world.m_name.toUpperCase().startsWith("HTTP://")
                     &&
                     !(m_world.m_name.toUpperCase().indexOf("/W?")!=-1||m_world.m_name.toUpperCase().indexOf("/ORL?")!=-1)
                 )       
                 || space.vmw_container.isDemo() //20061203
                )
                space.post.disable();
            else
                space.post.enable();
    }
    
    
    public void setTransporter() {
        if (!vmw_container.isApplet()) {
            String peerOn = vmw_container.getParameter("peer");
            if (peerOn!=null && peerOn.equalsIgnoreCase("on"))
                m_transporter = new MITransporter(this);
        }
    }


    /**
     * Returns absolute path for data and images sdjusted to th elocation of the current world file
     * @since 20070429
     */
    public String getPath(String i_path)//20070429
    {
    	if (i_path==null || i_path.length()<=0)//20070501
    		return null;
        if (vmw_container.isApplet()) {
            if (i_path.toUpperCase().startsWith("HTTP")) {
                if (VMToolkit.isTheSameServer(m_imagebase,i_path))
                    // get file from complete URL
                    return i_path;
                else 
                if (m_imagebase.endsWith("?"))
                    // get file URL from other server piped via servlet
                    return m_imagebase+i_path;
                else
                    return null;
            }
            else 
                // get file from relational URL
                return m_imagebase+i_path;
        } 
        else {    
            if (i_path.toUpperCase().startsWith("HTTP")) 
                // get image from complete URL
                return i_path;
            else   
            if (m_imagebase.toUpperCase().startsWith("HTTP")) 
                // get image from relational URL
                return m_imagebase+i_path;
            else {
                // get image from file
            	return i_path.indexOf(":")!=-1 || i_path.charAt(0)=='\\' || i_path.charAt(0)=='/' ?
            			i_path : m_imagebase+i_path;
            }
        }
    }

    protected Image getImage(String i_image)
    {
                    if (vmw_container.isApplet()) {
                        if (i_image.toUpperCase().startsWith("HTTP")) {
                            if (VMToolkit.isTheSameServer(m_imagebase,i_image)) {
                                // get image from complete URL
                                return VMToolkit.getImage(this,i_image);
                            }
                            else 
                            if (m_imagebase.endsWith("?")) {
                                // get image URL from other server piped via servlet
                                return VMToolkit.getImage(this,m_imagebase+i_image);
                            }
                            else
                                return null;
                        }
                        else {
                            // get image from relational URL
                            return VMToolkit.getImage(this,m_imagebase+i_image);
                        }
                    } 
                    else {    
                        if (i_image.toUpperCase().startsWith("HTTP")) {
                            // get image from complete URL
                            return VMToolkit.getImage(this,i_image);
                        }
                        else   
                        if (m_imagebase.toUpperCase().startsWith("HTTP")) {
                            // get image from relational URL
                            return VMToolkit.getImage(this,m_imagebase+i_image);
                        }
                        else {
                            // get image from file
                        	String imagePath = i_image.indexOf(":")!=-1 || i_image.charAt(0)=='\\' || i_image.charAt(0)=='/' ?
                        			i_image : m_imagebase+i_image;//20070406
                            return m_toolkit.getImage(imagePath);//20070406
                        }
                    }
    }
    
    
    public void runConsole(boolean i_show) {
        if (console==null)
        {
            console=new VMConsole(vmw_container,m_world,this,
            		VMResource.getString(vmw_container.getName())+" "+VMResource.getString("Console"));
            console.resetSize();
        }
        if (i_show)
        {
            console.resetSize();
            space.console.showFrame();
            space.console.toFront();//if visible
        }
        else
        {
            space.console.hideFrame();
        }
    }
    
    
    protected boolean toConsole(String i_text)
    {
  	    if (console!=null)
  	    {
  	        console.m_textarea.appendText(i_text);
  	        console.toFront();//if visible
  	        return true;
  	    }
        return false;
  	}
    public void setClickMode(String mode)
    {
        if (click!=null && mode!=null) click.select(mode);
    }
    public String getClickMode()
    {
        if (click==null) return null;
        return click.getSelectedItem();
    }
    public boolean getDraftMode()//20061111
    {
        return draft!=null && draft.getState();
    }
    public boolean getAimMode()//20061111
    {
        return aim!=null && aim.getState();
    }
    public boolean getAnimateMode()//20061111
    {
        return animate!=null && animate.getState();
    }
    public void setDraftMode(boolean mode)//20061111
    {
        if (draft!=null) draft.setState(mode);
    }
    public void setAimMode(boolean mode)//20061111
    {
        if (aim!=null) aim.setState(mode);
    }
    public void setAnimateMode(boolean mode)//20061111
    {
        if (animate!=null) animate.setState(mode);
    }

    protected String getParameter(String name,String defValue)
    {
        return vmw_container.getParameter(name,defValue);
    }

    protected void setParameter(String name,String value)
    {
        vmw_container.setParameter(name,value);
    }
    
    /*
    //deprecated
    public void Message(String msg)
    {
        message(msg);
    }*/

    /** resets views after the merge from outside done by transporter's peer
        @since 20010401
    */
    public void resetViews() {
        if (has_GUI) {
            setViewPoints();
            panel.repaint();
        }
    }

    public void resetToolbar(VMProjector projector)
    {
        String current; 
        
        current = click.getSelectedItem();

//System.out.println("click mode="+current);
            
        click.removeAll();
        String[] clickActions=projector.clickActions();
        for (int i=0;i<clickActions.length;i++)
            click.addItem(clickActions[i]);
        if (current!=null)
            click.select(current);
            
        drag.removeAll();
        current = drag.getSelectedItem();
        String[] dragActions=projector.dragActions();
        for (int j=0;j<dragActions.length;j++)
            drag.addItem(dragActions[j]);

//System.out.println("drag mode="+current);

        if (current!=null)
            drag.select(current);
            
        cpanel.layout();    
    }
    


    /**
    * Dumps world to a string
    * @since 20010126
    */
    public String toString(MIWorld a_world)
    {
                java.io.StringWriter  sw = new java.io.StringWriter();
                java.io.BufferedWriter bw = new java.io.BufferedWriter(sw);
                MIStream st = new MIStream(a_world);
                st.init(null,bw);
                a_world.save(st);
                st.flush();
                String t=sw.getBuffer().toString();
                st.stop();
                return t;
    }
    

    /**
    * Gets all resent changes made in the space's world
    * @since 20010126
    */
    public String getChanges()
    {
/**        
        return toString(m_world);
**/
          java.io.StringWriter  sw = new java.io.StringWriter();
          java.io.BufferedWriter bw = new java.io.BufferedWriter(sw);
          MIStream st = new MIStream(m_world);
          st.init(null,bw);
          m_world.saveChanges(st);
          st.flush();
          String t=sw.getBuffer().toString();
          st.stop();
          
//System.out.println("CHANGES:\n"+t);          
          
          return t;
/**/          
    }
    

}