(in-package :user) ;

; cache for dimensions
(defvar *dimensions* (make-array *dimensions-count* :element-type 'dimension))

(defvar *value-value-map*)

;(defvar *item-family-instance-map*)

(defvar *dim-id-no-map*)

(defun dim-no-by-id(dim-id)
	(gethash dim-id *dim-id-no-map*)
	)

(defun check-maps()
	; create dimension number lookup table
	(setq *dim-id-no-map* (make-hash-table))
	; create list of dimensions
	;(map nil #'(lambda(n) (if (not (retrieve-from-index 'dimension 'name n)) 
	;	(make-instance 'dimension :name n))) *dimension-names* )
	(do ((i 0 (1+ i))) ((>= i (length *dimension-names*)))
		(setf (aref *dimensions* i) 
			(retrieve-from-index 'dimension 'name (aref *dimension-names* i))
			)
		(if (not (aref *dimensions* i))
			(setf (aref *dimensions* i) 
				(make-dimension (aref *dimension-names* i))
				)
			)
		(setf (gethash (get-id (aref *dimensions* i)) *dim-id-no-map*) i)
		);do
	; create class maps
	(setq *value-value-map* (retrieve-from-index 'ac-map-range 'ac-map-name "value-value"))
	(if (not *value-value-map*)
		(setq *value-value-map* (make-instance 'ac-map-range :ac-map-name "value-value"))			
		)
		
	;(setq *item-family-instance-map* (retrieve-from-index 'ac-map-range 'ac-map-name "item-family-instance"))
	;(if (not *item-family-instance-map*)
	;	(setq *item-family-instance-map* (make-instance 'ac-map-range :ac-map-name "item-family-instance"))
	;	)
	
	(families-init)
	(commit)
	)

;; open database and create dimension if needed
(defun uom-start (path)
	(db.ac:open-file-database path  
			:if-does-not-exist :create 
			:if-exists :supersede 
			; with this restriction, uom qa runs too slow
		    ; :object-cache-size (* 1 1024 1024 1024 ) ; the default is much smaller really
		    ; :class-cache-size (* 4 1024 1024 1024 ) ; no default restriction
			)
	(check-maps)
	)

(defun uom-open (path)
	(db.ac:open-file-database path
			; with this restriction, uom qa runs too slow
		    ; :object-cache-size (* 1 1024 1024 1024 ) ; the default is much smaller really
		    ; :class-cache-size (* 4 1024 1024 1024 ) ; no default restriction
		    )
	(check-maps)
	)

(defun uom-stop ()
	(db.ac:close-database)
	)

(defun refresh-all()
	(gc :tenure)
	(gc t)
;	(db.ac:flush-object-cache :all t) ; Eugene suggested this bu it does not work by some reason?
	)

